<template>
  <input
    ref="refInputMask"
    v-imask="mask"
    :value="value"
    class="form-control form-control-flush queryfactory-condition-input w-100 h-100 rounded-0"
    :disabled="disabled"
    @accept="onAccept"
    @complete="onComplete"
    @input="onInput"
  />
</template>

<script>
import { IMaskDirective } from 'vue-imask';

export default {
  directives: {
    imask: IMaskDirective,
  },
  props: {
    value: {
      type: String,
      default: () => '',
      required: true,
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    rule: {
      type: Object,
      default: () => {},
    },
    ruleProperties: {
      type: Object,
      default: () => {},
    },
    customMask: {
      type: Function,
      required: true,
      default: () => ({}),
    },
  },
  data() {
    return {
      mask: null,
    };
  },
  computed: {},
  watch: {
    rule() {
      this.mask = this.customMask();
    },
  },
  created() {
    // create the mask to be used
    this.mask = this.customMask();
  },
  mounted() {
    if (this.isValueEmpty()) {
      this.$set(this.rule, 'isDataCompleted', false);
    }
  },
  methods: {
    getParsedString(value) {
      let isAccepted = true;
      // number
      if (this.rule.type === 'number') {
        const numericValue = parseFloat(value);
        if (isNaN(numericValue)) {
          isAccepted = false;
        }
      }
      return { data: value, isAccepted: value.length && isAccepted };
    },
    emitParsedValue(value, isDataCompleted = true) {
      if (this.disabled) return;
      const parsedValue = this.getParsedString(value);
      this.$set(
        this.rule,
        'isDataCompleted',
        isDataCompleted && parsedValue.isAccepted
      );
      this.$emit('input', parsedValue.data);
    },
    onAccept(e) {
      const maskRef = e.detail;
      this.emitParsedValue(maskRef.value, false);
    },
    onComplete(e) {
      const maskRef = e.detail;
      this.emitParsedValue(maskRef.value, true);
      this.$emit('inputCompleted', this.rule);
    },
    isValueEmpty() {
      return (
        this.value === null || this.value === '' || this.value === undefined
      );
    },
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    onInput(el) {},
  },
};
</script>
